Index: xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxcb.c
===================================================================
--- xorg-server-7.2.0.0-1.5.99.1.orig/hw/dmx/dmxcb.c
+++ xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxcb.c
@@ -42,6 +42,7 @@
 #include "dmxcb.h"
 #include "dmxinput.h"
 #include "dmxlog.h"
+#include "dmxwindow.h"
 
 extern char    *ConnectionInfo;
 extern int     connBlockScreenStart;
@@ -50,6 +51,8 @@ extern int     connBlockScreenStart;
 extern int     PanoramiXPixWidth;
 extern int     PanoramiXPixHeight;
 extern int     PanoramiXNumScreens;
+#include "panoramiX.h"
+#include "panoramiXsrv.h"
 #endif
 
        int     dmxGlobalWidth, dmxGlobalHeight;
@@ -64,46 +67,100 @@ void dmxSetWidthHeight(int width, int he
     dmxGlobalHeight = height;
 }
 
-/** Computes the global bounding box for DMX.  This may be larger than
- * the one computed by Xinerama because of the DMX configuration
- * file. */
-void dmxComputeWidthHeight(DMXRecomputeFlag flag)
+void dmxComputeWidthHeight(void)
 {
-    int           i;
-    DMXScreenInfo *dmxScreen;
-    int           w = 0;
-    int           h = 0;
+    int       i;
+    ScreenPtr pScreen;
+    int       w = 0;
+    int       h = 0;
     
     for (i = 0; i < dmxNumScreens; i++) {
-                                /* Don't use root* here because this is
-                                 * the global bounding box. */
-        dmxScreen = &dmxScreens[i];
-        if (w < dmxScreen->scrnWidth + dmxScreen->rootXOrigin)
-            w = dmxScreen->scrnWidth + dmxScreen->rootXOrigin;
-        if (h < dmxScreen->scrnHeight + dmxScreen->rootYOrigin)
-            h = dmxScreen->scrnHeight + dmxScreen->rootYOrigin;
+	pScreen = screenInfo.screens[i];
+        if (w < pScreen->width)
+            w = pScreen->width;
+        if (h < pScreen->height)
+            h = pScreen->height;
     }
-    if (!dmxGlobalWidth && !dmxGlobalHeight) {
-        dmxLog(dmxInfo, "Using %dx%d as global bounding box\n", w, h);
-    } else {
-        switch (flag) {
-        case DMX_NO_RECOMPUTE_BOUNDING_BOX:
-            dmxLog(dmxInfo,
-                   "Using old bounding box (%dx%d) instead of new (%dx%d)\n",
-                   dmxGlobalWidth, dmxGlobalHeight, w, h);
-            w = dmxGlobalWidth;
-            h = dmxGlobalHeight;
-            break;
-        case DMX_RECOMPUTE_BOUNDING_BOX:
-            dmxLog(dmxInfo,
-                   "Using %dx%d as global bounding box, instead of %dx%d\n",
-                   w, h, dmxGlobalWidth, dmxGlobalHeight);
-            break;
-        }
+
+    dmxSetWidthHeight (w, h);
+}
+
+static Bool
+dmxCreateInputOverlayWindow (void)
+{
+    WindowPtr pWin;
+    XID       inputOverlayWid;
+    XID       overrideRedirect = TRUE;
+    int	      result;
+    Atom      xdndVersion = 5;
+
+    if (dmxScreens[0].inputOverlayWid)
+	return TRUE;
+
+    inputOverlayWid = FakeClientID (0);
+
+#ifdef PANORAMIX
+    if (!noPanoramiXExtension)
+    {
+	PanoramiXRes *newWin;
+	int          j;
+
+	if (!(newWin = (PanoramiXRes *) xalloc (sizeof (PanoramiXRes))))
+	    return BadAlloc;
+
+	newWin->type = XRT_WINDOW;
+	newWin->u.win.visibility = VisibilityNotViewable;
+	newWin->u.win.class = InputOnly;
+	newWin->u.win.root = FALSE;
+	newWin->info[0].id = inputOverlayWid;
+	for(j = 1; j < PanoramiXNumScreens; j++)
+	    newWin->info[j].id = FakeClientID (0);
+
+	FOR_NSCREENS_BACKWARD(j) {
+	    pWin = CreateWindow (newWin->info[j].id, WindowTable[j],
+				 -1, -1, 1, 1, 0, InputOnly, 
+				 CWOverrideRedirect, &overrideRedirect,
+				 0, serverClient, CopyFromParent, 
+				 &result);
+	    if (result != Success)
+		return FALSE;
+	    if (!AddResource (pWin->drawable.id, RT_WINDOW, pWin))
+		return FALSE;
+
+	    dmxScreens[j].inputOverlayWid = inputOverlayWid;
+	    dmxScreens[j].pInputOverlayWin = pWin;
+	}
+
+	AddResource (newWin->info[0].id, XRT_WINDOW, newWin);
     }
-        
-    dmxGlobalWidth  = w;
-    dmxGlobalHeight = h;
+    else
+#endif
+	
+    {
+	pWin = CreateWindow (inputOverlayWid, WindowTable[0],
+			     -1, -1, 1, 1, 0, InputOnly, 
+			     CWOverrideRedirect, &overrideRedirect,
+			     0, serverClient, CopyFromParent, 
+			     &result);
+	if (result != Success)
+	    return FALSE;
+	if (!AddResource (pWin->drawable.id, RT_WINDOW, pWin))
+	    return FALSE;
+
+	dmxScreens[0].inputOverlayWid = inputOverlayWid;
+	dmxScreens[0].pInputOverlayWin = pWin;
+    }
+
+    ChangeWindowProperty (dmxScreens[0].pInputOverlayWin,
+			  dmxScreens[0].xdndAwareAtom,
+			  XA_ATOM,
+			  32,
+			  PropModeReplace,
+			  1,
+			  &xdndVersion,
+			  TRUE);
+
+    return TRUE;
 }
 
 /** A callback routine that hooks into Xinerama and provides a
@@ -198,7 +255,6 @@ void dmxConnectionBlockCallback(void)
         offset = voffset + depth->nVisuals * sizeof(xVisualType);
     }
 
-    dmxInputLogDevices();
     dmxLog(dmxInfo, "===== End of Summary =====\n");
 
 #ifdef PANORAMIX
@@ -220,4 +276,7 @@ void dmxConnectionBlockCallback(void)
     }
 #endif
     MAXSCREENSFREE(found);
+
+    if (!dmxCreateInputOverlayWindow ())
+	dmxLog (dmxFatal, "dmxCreateInputOverlayWindow: failed");
 }
Index: xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxcb.h
===================================================================
--- xorg-server-7.2.0.0-1.5.99.1.orig/hw/dmx/dmxcb.h
+++ xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxcb.h
@@ -40,14 +40,7 @@
 /** The cursor position, in global coordinates. */
 extern int  dmxGlobalWidth, dmxGlobalHeight;
 
-/** #dmxComputeWidthHeight can either recompute the global bounding box
- * or not. */
-typedef enum {
-    DMX_RECOMPUTE_BOUNDING_BOX,
-    DMX_NO_RECOMPUTE_BOUNDING_BOX
-} DMXRecomputeFlag;
-
 extern void dmxSetWidthHeight(int width, int height);
-extern void dmxComputeWidthHeight(DMXRecomputeFlag flag);
+extern void dmxComputeWidthHeight(void);
 extern void dmxConnectionBlockCallback(void);
 #endif
Index: xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxclient.h
===================================================================
--- xorg-server-7.2.0.0-1.5.99.1.orig/hw/dmx/dmxclient.h
+++ xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxclient.h
@@ -72,6 +72,11 @@ typedef XID           KeySym64;
 #define Colormap      Colormap64
 #define GContext      GContext64
 #define KeySym        KeySym64
+#ifdef RANDR
+#define RRMode        RRMode64
+#define RROutput      RROutput64
+#define RRCrtc        RRCrtc64
+#endif
 #endif
 
 #include <X11/Xlib.h>
@@ -91,16 +96,25 @@ typedef XID           KeySym64;
 #undef PictFormatType
 #endif
 
+#ifdef RANDR
+#include <X11/extensions/Xrandr.h>
+#endif
+
 #ifdef XKB
 #include <X11/extensions/XKB.h>
 #include <X11/extensions/XKBstr.h>
 #endif
 
+#ifdef XV
+#include <X11/extensions/Xvlib.h>
+#endif
+
 #include <X11/extensions/XI.h>
 
 /* Always include these, since we query them even if we don't export XINPUT. */
 #include <X11/extensions/XInput.h> /* For XDevice */
 #include <X11/extensions/Xext.h>
+#include <X11/extensions/Xcomposite.h>
 
 #undef GC
 
@@ -119,6 +133,11 @@ typedef XID           KeySym64;
 #undef Colormap
 #undef GContext
 #undef KeySym
+#ifdef RANDR
+#undef RRMode
+#undef RROutput
+#undef RRCrtc
+#endif
 #endif
 
 /* These are in exglobals.h, but that conflicts with xkbsrv.h */
Index: xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxcmap.c
===================================================================
--- xorg-server-7.2.0.0-1.5.99.1.orig/hw/dmx/dmxcmap.c
+++ xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxcmap.c
@@ -70,12 +70,15 @@ Bool dmxBECreateColormap(ColormapPtr pCo
     Visual             *visual    = dmxLookupVisual(pScreen, pVisual);
 
     if (visual) {
-       pCmapPriv->cmap = XCreateColormap(dmxScreen->beDisplay,
-                                         dmxScreen->scrnWin,
-                                         visual,
-                                         (pVisual->class & DynamicClass ?
-                                          AllocAll : AllocNone));
-       return (pCmapPriv->cmap != 0);
+	pCmapPriv->cmap = 0;
+	XLIB_PROLOGUE (dmxScreen);
+	pCmapPriv->cmap = XCreateColormap(dmxScreen->beDisplay,
+					  dmxScreen->scrnWin,
+					  visual,
+					  (pVisual->class & DynamicClass ?
+					   AllocAll : AllocNone));
+	XLIB_EPILOGUE (dmxScreen);
+	return (pCmapPriv->cmap != 0);
     }
     else {
        dmxLog(dmxWarning, "dmxBECreateColormap: No visual found\n");
@@ -115,7 +118,9 @@ Bool dmxBEFreeColormap(ColormapPtr pColo
     dmxColormapPrivPtr  pCmapPriv = DMX_GET_COLORMAP_PRIV(pColormap);
 
     if (pCmapPriv->cmap) {
+	XLIB_PROLOGUE (dmxScreen);
 	XFreeColormap(dmxScreen->beDisplay, pCmapPriv->cmap);
+	XLIB_EPILOGUE (dmxScreen);
 	pCmapPriv->cmap = (Colormap)0;
 	return TRUE;
     }
@@ -156,7 +161,9 @@ void dmxInstallColormap(ColormapPtr pCol
     DMX_WRAP(InstallColormap, dmxInstallColormap, dmxScreen, pScreen);
 
     if (dmxScreen->beDisplay) {
+	XLIB_PROLOGUE (dmxScreen);
 	XInstallColormap(dmxScreen->beDisplay, pCmapPriv->cmap);
+	XLIB_EPILOGUE (dmxScreen);
 	dmxSync(dmxScreen, FALSE);
     }
 }
@@ -182,7 +189,9 @@ void dmxStoreColors(ColormapPtr pColorma
                 color[i].flags = pdef[i].flags;
                 color[i].pad   = pdef[i].pad;
             }
+	    XLIB_PROLOGUE (dmxScreen);
             XStoreColors(dmxScreen->beDisplay, pCmapPriv->cmap, color, ndef);
+	    XLIB_EPILOGUE (dmxScreen);
             xfree(color);
         } else {                /* xalloc failed, so fallback */
             XColor c;
@@ -193,7 +202,9 @@ void dmxStoreColors(ColormapPtr pColorma
                 c.green = pdef[i].green;
                 c.flags = pdef[i].flags;
                 c.pad   = pdef[i].pad;
+		XLIB_PROLOGUE (dmxScreen);
                 XStoreColor(dmxScreen->beDisplay, pCmapPriv->cmap, &c);
+		XLIB_EPILOGUE (dmxScreen);
             }
         }
 	dmxSync(dmxScreen, FALSE);
Index: xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxcomp.c
===================================================================
--- /dev/null
+++ xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxcomp.c
@@ -0,0 +1,199 @@
+/*
+ * Copyright © 2008 Novell, Inc.
+ *
+ * Permission to use, copy, modify, distribute, and sell this software
+ * and its documentation for any purpose is hereby granted without
+ * fee, provided that the above copyright notice appear in all copies
+ * and that both that copyright notice and this permission notice
+ * appear in supporting documentation, and that the name of
+ * Novell, Inc. not be used in advertising or publicity pertaining to
+ * distribution of the software without specific, written prior permission.
+ * Novell, Inc. makes no representations about the suitability of this
+ * software for any purpose. It is provided "as is" without express or
+ * implied warranty.
+ *
+ * NOVELL, INC. DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
+ * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN
+ * NO EVENT SHALL NOVELL, INC. BE LIABLE FOR ANY SPECIAL, INDIRECT OR
+ * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS
+ * OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
+ * NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
+ * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ *
+ * Author: David Reveman <davidr@novell.com>
+ */
+
+#ifdef HAVE_DMX_CONFIG_H
+#include <dmx-config.h>
+#endif
+
+#include "dmx.h"
+#include "dmxcomp.h"
+#include "compint.h"
+
+extern int (*ProcCompositeVector[CompositeNumberRequests]) (ClientPtr);
+static int (*dmxSaveCompositeVector[CompositeNumberRequests]) (ClientPtr);
+
+unsigned long DMX_CLIENTWINDOW;
+unsigned long DMX_CLIENTSUBWINDOWS;
+
+static int
+dmxProcCompositeRedirectWindow (ClientPtr client)
+{
+    WindowPtr	pWin;
+    int rc;
+    REQUEST(xCompositeRedirectWindowReq);
+
+    REQUEST_SIZE_MATCH(xCompositeRedirectWindowReq);
+
+    rc = dixLookupResource((pointer *)&pWin, stuff->window, RT_WINDOW, client,
+			   DixSetAttrAccess|DixManageAccess|DixBlendAccess);
+    if (rc != Success)
+    {
+	client->errorValue = stuff->window;
+	return (rc == BadValue) ? BadWindow : rc;
+    }
+
+    /* Add implicit CompositeRedirectManual. This prevents clients
+       from using CompositeRedirectManual and composite extension from
+       handling window updates. Window updates are handled by
+       back-end servers. */
+    if (!GetCompWindow (pWin))
+    {
+	rc = compRedirectWindow (serverClient, pWin, CompositeRedirectManual);
+	if (rc != Success)
+	    return rc;
+    }
+
+    rc = compRedirectWindow (client, pWin, stuff->update);
+    if (rc == Success)
+    {
+	AddResource (GetCompWindow (pWin)->clients->id,
+		     DMX_CLIENTWINDOW,
+		     pWin);
+    }
+    else
+    {
+	if (!GetCompWindow (pWin)->clients->next)
+	    compUnredirectWindow (serverClient, pWin, CompositeRedirectManual);
+    }
+
+    return rc;
+}
+
+static int
+dmxProcCompositeRedirectSubwindows (ClientPtr client)
+{
+    WindowPtr	pWin;
+    int rc;
+    REQUEST(xCompositeRedirectSubwindowsReq);
+
+    REQUEST_SIZE_MATCH(xCompositeRedirectSubwindowsReq);
+
+    rc = dixLookupResource((pointer *)&pWin, stuff->window, RT_WINDOW, client,
+			   DixSetAttrAccess|DixManageAccess|DixBlendAccess);
+    if (rc != Success)
+    {
+	client->errorValue = stuff->window;
+	return (rc == BadValue) ? BadWindow : rc;
+    }
+
+    if (!GetCompSubwindows (pWin))
+    {
+	rc = compRedirectSubwindows (serverClient, pWin,
+				     CompositeRedirectManual);
+	if (rc != Success)
+	    return rc;
+    }
+
+    rc = compRedirectSubwindows (client, pWin, stuff->update);
+    if (rc == Success)
+    {
+	AddResource (GetCompSubwindows (pWin)->clients->id,
+		     DMX_CLIENTSUBWINDOWS,
+		     pWin);
+    }
+    else
+    {
+	if (!GetCompSubwindows (pWin)->clients->next)
+	    compUnredirectSubwindows (serverClient, pWin,
+				      CompositeRedirectManual);
+    }
+
+    return rc;
+}
+
+static int
+dmxFreeCompositeClientWindow (pointer value, XID ccwid)
+{
+    WindowPtr	        pWin = value;
+    CompWindowPtr	cw = GetCompWindow (pWin);
+    CompClientWindowPtr	ccw;
+    int		        count = 0;
+
+    for (ccw = cw->clients; ccw; ccw = ccw->next)
+	if (ccw->update != CompositeRedirectManual)
+	    count++;
+
+    /* free our implicit manual redirect if that's the only one left */
+    if (count <= 1)
+	compUnredirectWindow (serverClient, pWin, CompositeRedirectManual);
+
+    return Success;
+}
+
+static int
+dmxFreeCompositeClientSubwindows (pointer value, XID ccwid)
+{
+    WindowPtr	        pWin = value;
+    CompSubwindowsPtr   csw = GetCompSubwindows (pWin);
+    CompClientWindowPtr	ccw;
+    int		        count = 0;
+
+    for (ccw = csw->clients; ccw; ccw = ccw->next)
+	if (ccw->update != CompositeRedirectManual)
+	    count++;
+
+    /* free our implicit manual redirect if that's the only one left */
+    if (count <= 1)
+	compUnredirectSubwindows (serverClient, pWin,
+				  CompositeRedirectManual);
+
+    return Success;
+}
+
+/** Initialize the Proc Vector for the Composite extension.  The functions
+ *  here cannot be handled by the mi layer Composite hooks either because
+ *  the required information is no longer available when it reaches the
+ *  mi layer or no mi layer hooks exist.  This function is called from
+ *  InitOutput() since it should be initialized only once per server
+ *  generation. */
+void
+dmxInitComposite (void)
+{
+    int i;
+
+    DMX_CLIENTWINDOW = CreateNewResourceType (dmxFreeCompositeClientWindow);
+    DMX_CLIENTSUBWINDOWS =
+	CreateNewResourceType (dmxFreeCompositeClientSubwindows);
+
+    for (i = 0; i < CompositeNumberRequests; i++)
+        dmxSaveCompositeVector[i] = ProcCompositeVector[i];
+
+    ProcCompositeVector[X_CompositeRedirectWindow]
+	= dmxProcCompositeRedirectWindow;
+    ProcCompositeVector[X_CompositeRedirectSubwindows]
+	= dmxProcCompositeRedirectSubwindows;
+}
+
+/** Reset the Proc Vector for the Composite extension back to the original
+ *  functions.  This function is called from dmxCloseScreen() during the
+ *  server reset (only for screen #0). */
+void
+dmxResetComposite (void)
+{
+    int i;
+
+    for (i = 0; i < CompositeNumberRequests; i++)
+        ProcCompositeVector[i] = dmxSaveCompositeVector[i];
+}
Index: xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxcomp.h
===================================================================
--- /dev/null
+++ xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxcomp.h
@@ -0,0 +1,35 @@
+/*
+ * Copyright © 2008 Novell, Inc.
+ *
+ * Permission to use, copy, modify, distribute, and sell this software
+ * and its documentation for any purpose is hereby granted without
+ * fee, provided that the above copyright notice appear in all copies
+ * and that both that copyright notice and this permission notice
+ * appear in supporting documentation, and that the name of
+ * Novell, Inc. not be used in advertising or publicity pertaining to
+ * distribution of the software without specific, written prior permission.
+ * Novell, Inc. makes no representations about the suitability of this
+ * software for any purpose. It is provided "as is" without express or
+ * implied warranty.
+ *
+ * NOVELL, INC. DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
+ * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN
+ * NO EVENT SHALL NOVELL, INC. BE LIABLE FOR ANY SPECIAL, INDIRECT OR
+ * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS
+ * OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
+ * NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
+ * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ *
+ * Author: David Reveman <davidr@novell.com>
+ */
+
+#ifndef DMXCOMP_H
+#define DMXCOMP_H
+
+void
+dmxInitComposite (void);
+
+void
+dmxResetComposite (void);
+
+#endif /* DMXCOMP_H */
